<?php

if (!isset($_REQUEST['command'])) {echo "Hello my World!";exit();}

include_once "../../config.php";
include_once "../../smallfunc.php";
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');


if ($GLOBALS ["UseKASPI"] != 'True'){exit();}


if ($GLOBALS ["UseKASPI_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['KASPI_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		sendError(8, 'Запрос выполнен из неразрешенного адреса',-1,-1);
	}
}

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    sendError(300, 'Невозможно установить соединение с БД',-1,-1);
}


$command = $_REQUEST['command'];
switch ($command) {
    case 'check':
        check($_REQUEST['txn_id'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    case 'pay':
        pay($_REQUEST['txn_id'], $_REQUEST['txn_date'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    default:
        sendError(300, 'Неизвестная команда',-1,-1);
}

function check($payId, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    
    $stm = $connection->prepare("SELECT `contract`, FIO AS `fio`, `ballance`, `pinfo`, `otherinfo`, `tarif`, `tarif_guid`, `group_guid` FROM `stat` WHERE (UPPER(user_name) = ? or UPPER(contract) = ?)");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user) {
		
		$tarif_guid = $user['tarif_guid'];
		$group_guid = $user['group_guid'];
		
		$sql = "SELECT `params` FROM `payment_params` WHERE `type` = 30;";
		$mysqlResult = mysql_query($sql, $GLOBALS["mysql"]);
		
		$KaspiBIN='';
		
		while($row = mysql_fetch_array($mysqlResult)) { 
		
			$Params = GetParams($row[0]);

			$KaspiTariffsAndGroups = $Params['KaspiTariffsAndGroups'];
			$KaspiTariffsAndGroups = explode('*',trim($KaspiTariffsAndGroups,'*'));
			
			if ((strlen(array_search($tarif_guid, $KaspiTariffsAndGroups))>0)||(strlen(array_search($group_guid, $KaspiTariffsAndGroups))>0)){
				$KaspiBIN = $Params['KaspiBIN'];
				break;
			}
			
		}
		
		if ((float)$sum < 1) {
			sendError(241, 'Сумма слишком мала',-1,$KaspiBIN);
		}
		
		
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=str_replace(',','.',$bal);
		$pinfo=explode('||',$user['pinfo']);
		$otherinfo=explode('||',$user['otherinfo']);
		$adr=$pinfo[4];
		$rec_sum=$otherinfo[74];;
		$PayDay=$otherinfo[111];
		
        $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
        $response->addChild('kaspi_txn_id', $payId);
        $response->addChild('result', 0);
		
		$response->addChild('fio', $user['fio']);
		$response->addChild('address', $adr);
		$response->addChild('balance', $bal);
		$response->addChild('rec_sum', $rec_sum);
		$response->addChild('pay_day', $PayDay);
		
		if (strlen($KaspiBIN)>0){
			$response->addChild('bin', $KaspiBIN);
		}
		
        $response->addChild('comment', 'OK');
        writeToLog($response->asXML(), 'Ответ');
        echo $response->asXML();
    } else {
        sendError(1, 'Абонент не найден',-1,-1);
    }
}

function pay($payId, $date, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    

    $stm = $connection->prepare("SELECT `shortguid`, `tarif_guid`, `group_guid` FROM `stat` WHERE UPPER(`user_name`) = ? or UPPER(`contract`) = ?");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,30,?);");
		$stm->execute([time(), $sum, $account]);
        sendError(1, "Не найден идентификатор абонента",$payId,-1);
    }
	
	
	$tarif_guid = $user['tarif_guid'];
	$group_guid = $user['group_guid'];
	
	
	$sql = "SELECT `params` FROM `payment_params` WHERE `type` = 30;";
	$mysqlResult = mysql_query($sql, $GLOBALS["mysql"]);

	$KaspiBIN='';
		
	while($row = mysql_fetch_array($mysqlResult)) { 
		
		$Params = GetParams($row[0]);

		$KaspiTariffsAndGroups = $Params['KaspiTariffsAndGroups'];
		$KaspiTariffsAndGroups = explode('*',trim($KaspiTariffsAndGroups,'*'));
		
		if ((strlen(array_search($tarif_guid, $KaspiTariffsAndGroups))>0)||(strlen(array_search($group_guid, $KaspiTariffsAndGroups))>0)){
			$KaspiBIN = $Params['KaspiBIN'];
			break;
		}
			
	}
	
	$query = "SELECT id FROM operations_kaspi WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$payId]);
    $payment = $stm->fetch();
    if ($payment != false) {
        sendError(8, "Платёж уже был проведён",$payId,$KaspiBIN);
    }
	
	
	
	
    $dateTime = date("Y-m-d H:i:s", strtotime($date));
    $uid = uniqid("", true) . uniqid("", true);
    $stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'KASPI',0, ?, ?,?);");
    $stm->execute([$user['shortguid'], $sum, $uid, 'KASPI', $dateTime]);

    $stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','KASPI')");
    $stm->execute([$dateTime, $account, $sum]);

    //$stm = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $stm->execute();

    $query = "INSERT INTO operations_kaspi (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
    $stm = $connection->prepare($query);
    $stm->execute([$account, $sum, $payId, $dateTime]);
	
	

    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('kaspi_txn_id', $payId);
    $response->addChild('prv_txn', $connection->lastInsertId());
    $response->addChild('sum', $sum);
	
	if (strlen($KaspiBIN)>0){
		$response->addChild('bin', $KaspiBIN);
	}
	
    $response->addChild('result', '0');
    $response->addChild('comment', 'All is done');
    writeToLog($response->asXML(), 'Ответ');
    echo $response->asXML();
}

function sendError($code, $comment, $payId, $KaspiBIN)
{
    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('result', $code);
	if ($payId != -1){
		$response->addChild('kaspi_txn_id', $payId);
	}
	if (strlen($KaspiBIN)>0){
		$response->addChild('bin', $KaspiBIN);
	}
    $response->addChild('comment', $comment);
    echo $response->asXML();
    writeToLog($comment, 'Ответ');
    exit;
}

function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
