<?php

if (isset($_REQUEST['COMMAND'])){$_REQUEST['command']=$_REQUEST['COMMAND'];}
if ((isset($_REQUEST['ACTION']))&&(!isset($_REQUEST['command']))){$_REQUEST['command']=$_REQUEST['ACTION'];}
if (isset($_REQUEST['ACCOUNT'])){$_REQUEST['account']=$_REQUEST['ACCOUNT'];}
if (isset($_REQUEST['SUM'])){$_REQUEST['sum']=$_REQUEST['SUM'];}
if (isset($_REQUEST['TXN_ID'])){$_REQUEST['txn_id']=$_REQUEST['TXN_ID'];}
if (isset($_REQUEST['TXN_DATE'])){$_REQUEST['txn_date']=$_REQUEST['TXN_DATE'];}


if (!isset($_REQUEST['command'])) {echo "Hello my World!";exit();}

include_once "../../config.php";
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');


if ($GLOBALS ["UseOSMP_SBRF"] != 'True'){exit();}


if ($GLOBALS ["UseOSMP_SBRF_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['OSMP_SBRF_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		sendError(7, 'Запрос выполнен с неразрешенного адреса',-1);
	}
}

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    sendError(1, 'Невозможно установить соединение с БД',-1);
}


$command = $_REQUEST['command'];
switch ($command) {
    case 'check':
        check($_REQUEST['txn_id'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    case 'pay':
        pay($_REQUEST['txn_id'], $_REQUEST['txn_date'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    default:
        sendError(2, 'Неизвестная команда',-1);
}

function check($payId, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    //if ((float)$sum < 1) {
    //    sendError(9, 'Сумма слишком мала',-1);
    //}
    $stm = $connection->prepare("SELECT `contract`, FIO AS `fio`, `ballance`, `pinfo`, `otherinfo`, `tarif` FROM stat WHERE (UPPER(user_name) = ? or UPPER(contract) = ?)");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user) {
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=number_format(str_replace(',','.',$bal),2,'.','');
		$pinfo=explode('||',$user['pinfo']);
		$otherinfo=explode('||',$user['otherinfo']);
		$adr=$pinfo[4];
		$rec_sum=number_format($otherinfo[74],2,'.','');
        $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
        $response->addChild('txn_id', $payId);
        $response->addChild('result', 0);
		$response->addChild('comment', 'OK');
		$response->addChild('fio', $user['fio']);
		$response->addChild('address', $adr);
		$response->addChild('balance', $bal);
		$response->addChild('rec_sum', $rec_sum);
		$response->addChild('info', 'Тариф - "' . $user['tarif'].'"');        
        writeToLog($response->asXML(), 'Ответ');
        echo $response->asXML();
    } else {
        sendError(3, 'Абонент не найден',$payId);
    }
}

function pay($payId, $date, $account, $sum)
{
    global $connection;
	
	//if ((float)$sum < 1) {
    //    sendError(9, 'Сумма слишком мала',-1);
    //}
	
	$account=strtoupper($account);
    $query = "SELECT id FROM operations_osmp_sbrf WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$payId]);
    $payment = $stm->fetch();
    if ($payment != false) {
        sendError(8, "Платёж уже был проведён",$payId);
    }

    $stm = $connection->prepare("SELECT shortguid FROM stat WHERE UPPER(user_name) = ? or UPPER(contract) = ?");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,36,?);");
		$stm->execute([time(), $sum, $account]);
        sendError(3, "Не найден идентификатор абонента",$payId);
    }

    $dateTime = date("Y-m-d H:i:s");
    $uid = uniqid("", true) . uniqid("", true);
    $stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'SBRF_OSM',0, ?, ?,?);");
    $stm->execute([$user['shortguid'], $sum, $uid, 'Sberbank', $dateTime]);

    $stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','SBRF_OSM')");
    $stm->execute([$dateTime, $account, $sum]);

    //$stm = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $stm->execute();

    $query = "INSERT INTO operations_osmp_sbrf (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
    $stm = $connection->prepare($query);
    $stm->execute([$account, $sum, $payId, $dateTime]);

    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('txn_id', $payId);
    $response->addChild('result', '0');
    $response->addChild('comment', 'All is done');
    writeToLog($response->asXML(), 'Ответ');
    echo $response->asXML();
}

function sendError($code, $comment, $payId)
{
    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('result', $code);
	if ($payId != -1){
		$response->addChild('prv_txn', $payId);
	}
    $response->addChild('comment', $comment);
    echo $response->asXML();
    writeToLog($comment, 'Ответ');
    exit;
}

function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
