<?php
/**
 * Created by PhpStorm.
 * User: Delorian
 * Date: 23.02.2016
 * Time: 16:16
 */

if (!isset($_REQUEST['QueryType'])){
	echo "Hello my World!";
	exit();
}
 
include_once "../../config.php";
header('Content-Type: text/xml');

if ($GLOBALS ["UsePSB"] <> "True") {exit();}

if ($GLOBALS ["UsePSB_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['PSB_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		error(22, "Запрос выполнен с неразрешенного IP адреса!", -1);
	}
}

	$fp = fopen("payin2.txt", "a");
	fputs($fp, "\n\nDate = " . date("d.m.y H:i:s")."\n");
	fputs($fp, "URL = " . $_SERVER['REQUEST_URI']."\n");
	fputs($fp, "Args = " . print_r($_REQUEST,true) ."\n");
	


try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass']);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    error(23, 'Невозможно установить соединение с БД', -1);
}

if (isset($_REQUEST['QueryType']) and isset($_REQUEST['Account']) and isset($_REQUEST['TransactionId'])) {
    $action = $_REQUEST['QueryType'];
    $account = $_REQUEST['Account'];
    $transactionId = $_REQUEST['TransactionId'];

    switch ($action) {
        case 'check':
            check($transactionId, $account, $connection);
            exit;
            break;
        case 'pay':
            $transactionDate = date("Y-m-d H:i:s", strtotime($_REQUEST['TransactionDate']));
            $amount = $_REQUEST['Amount'];
            pay($transactionId, $transactionDate, $account, $amount, $connection);
            exit;
            break;
        default:
            error(23, 'Невозможно определить тип запроса', $transactionId);
            exit;
    }
}

if (isset($_REQUEST['CheckDateBegin']) and isset($_REQUEST['CheckDateEnd'])) {
    $start = date("Y-m-d H:i:s", strtotime($_REQUEST['CheckDateBegin']));
    $end = date("Y-m-d H:i:s", strtotime($_REQUEST['CheckDateEnd']));
    $query = "SELECT operation_id AS `transactionId`, contract AS `account`, sum AS `amount`, date AS `transactionDate` FROM `operations_psbank2` WHERE date BETWEEN ? AND ?";
    $statement = $connection->prepare($query);
    $statement->execute([$start, $end]);
    $payments = $statement->fetchAll(PDO::FETCH_ASSOC);

    $response = new SimpleXMLElement('<Response></Response>');
    foreach ($payments as $payment) {
        $paym = $response->addChild('Payment');
        $paym->addChild('TransactionId', $payment['transactionId']);
        $paym->addChild('Account', $payment['account']);
        $paym->addChild('TransactionDate', date('YmdHis', strtotime($payment['transactionDate'])));
        $paym->addChild('Amount', $payment['amount']);
    }
    echo $response->asXML();
    exit;
}

error(3, 'Неверный формат запроса', -1);

/**
 * @param string $transactionId идентификатор транзакции
 * @param string $account номер договора абонента
 * @param PDO $connection соединение с БД
 */
function check($transactionId, $account, $connection)
{
    $query = "SELECT FIO AS name, ballance AS balance FROM stat WHERE user_name = ? or contract = ?";
    $statement = $connection->prepare($query);
    $statement->execute([$account,$account]);
    $user = $statement->fetch(PDO::FETCH_ASSOC);
    if ($user == false) {
        error(21, 'Идентификатор абонента не найден', $transactionId);
        exit;
    }

    $response = '<?xml version="1.0" encoding="UTF-8"?>
                    <Response>
                        <TransactionId>' . $transactionId . '</TransactionId>
                        <ResultCode>0</ResultCode>
                        <Fields>
                            <field1 name="name">' . $user['name'] . '</field1>
                            <field2 name="balance">' . $user['balance'] . '</field2>
                        </Fields>
                        <Comment></Comment>
                    </Response>';
    echo $response;
}

/**
 * @param string $transactionId идентификатор транзакции
 * @param string $transactionDate дата транзакции
 * @param string $account номер договора абонента
 * @param float $amount сумма к начислению
 * @param PDO $connection соединение с БД
 */
function pay($transactionId, $transactionDate, $account, $amount, $connection)
{

    $query = "SELECT COUNT(*) AS `rows` FROM `operations_psbank2` WHERE operation_id = ?";
    $statement = $connection->prepare($query);
    $statement->execute([$transactionId]);
    $payments = $statement->fetch(PDO::FETCH_ASSOC);

    if ($payments['rows'] > 0) {
        error(22, 'Платеж уже был проведен', $transactionId);
    }

    $statement = $connection->prepare("SELECT stat.shortguid FROM stat WHERE user_name = ? or contract = ?");
    $statement->execute([$account,$account]);
    $userId = $statement->fetch(PDO::FETCH_ASSOC);
    if ($userId == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,10,?);");
		$stm->execute([time(), $amount, $account]);
        error(3, "Не найден пользователь, невозможно пополнить баланс", $transactionId);
    }

    $payer = 'PSBank';
    $dateTime = $transactionDate;
    $uid = uniqid("", true) . uniqid("", true);
    $statement = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'$payer',0, ?,?,?);");
    $statement->execute([$userId['shortguid'], $amount, $uid, $payer, $dateTime]);

    $statement = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'',?)");
    $statement->execute([$dateTime, $account, $amount, $payer]);

    //$statement = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$statement = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $statement->execute();

    $query = "INSERT INTO `operations_psbank2` (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
    $statement = $connection->prepare($query);
    $statement->execute([$account, $amount, $transactionId, $transactionDate]);

    $response = '<?xml version="1.0" encoding="UTF-8"?>
    <Response>
        <TransactionId>' . $transactionId . '</TransactionId>
        <TransactionExt>' . $connection->lastInsertId() . '</TransactionExt>
        <Amount>' . $amount . '</Amount>
        <ResultCode>0</ResultCode>
        <Comment></Comment>
    </Response>';

    echo $response;
    exit;
}

/**
 * @param int $code код ошибки
 * @param string $description Описание ошибки
 * @param string $transactionId идентификатор транзакции
 */
function error($code, $description, $transactionId)
{
    $response = '<?xml version="1.0" encoding="UTF-8"?>
                    <Response>
                        <TransactionId>' . $transactionId . '</TransactionId>
                        <ResultCode>' . $code . '</ResultCode>
                        <Comment>' . $description . '</Comment>
                    </Response>';
    echo $response;
    exit;
}